Index: issm/trunk/src/m/mesh/bamg.py
===================================================================
--- issm/trunk/src/m/mesh/bamg.py	(revision 25994)
+++ issm/trunk/src/m/mesh/bamg.py	(revision 26744)
@@ -23,47 +23,93 @@
     Available options (for more details see ISSM website http://issm.jpl.nasa.gov/):
 
-    - domain :            followed by an ARGUS file that prescribes the domain outline
-    - holes :             followed by an ARGUS file that prescribes the holes
-    - subdomains :        followed by an ARGUS file that prescribes the list of
-                        subdomains (that need to be inside domain)
-
-    - hmin :              minimum edge length (default is 1.0e - 100)
-    - hmax :              maximum edge length (default is 1.0e100)
-    - hVertices :         imposed edge length for each vertex (geometry or mesh)
-    - hminVertices :      minimum edge length for each vertex (mesh)
-    - hmaxVertices :      maximum edge length for each vertex (mesh)
-
-    - anisomax :          maximum ratio between the smallest and largest edges (default is 1.0e30)
-    - coeff :             coefficient applied to the metric (2 -> twice as many elements, default is 1)
-    - cutoff :            scalar used to compute the metric when metric type 2 or 3 are applied
-    - err :               error used to generate the metric from a field
-    - errg :              geometric error (default is 0.1)
-    - field :             field of the model that will be used to compute the metric
-                                   to apply several fields, use one column per field
-    - gradation :         maximum ratio between two adjacent edges
-    - Hessiantype :       0 -> use double P2 projection (default)
-                            1 -> use Green formula
-    - KeepVertices :      try to keep initial vertices when adaptation is done on an existing mesh (default 1)
-    - NoBoundaryRefinement: do not refine boundary, only follow contour provided (default 0). Allow subdomain boundary refinement though
-    - NoBoundaryRefinementAllBoundaries: do not refine boundary, only follow contour provided (default 0)
-    - maxnbv :            maximum number of vertices used to allocate memory (default is 1.0e6)
-    - maxsubdiv :         maximum subdivision of exisiting elements (default is 10)
-    - metric :            matrix (numberofnodes x 3) used as a metric
-    - Metrictype :        1 -> absolute error          c / (err coeff^2) * Abs(H)        (default)
-                                   2 -> relative error          c / (err coeff^2) * Abs(H) / max(s, cutoff * max(s))
-                                   3 -> rescaled absolute error c / (err coeff^2) * Abs(H) / (smax - smin)
-    - nbjacoby :          correction used by Hessiantype = 1 (default is 1)
-    - nbsmooth :          number of metric smoothing procedure (default is 3)
-    - omega :             relaxation parameter of the smoothing procedure (default is 1.8)
-    - power :             power applied to the metric (default is 1)
-    - splitcorners :      split triangles whuch have 3 vertices on the outline (default is 1)
-    - verbose :           level of verbosity (default is 1)
-
-    - rifts :             followed by an ARGUS file that prescribes the rifts
-    - toltip :            tolerance to move tip on an existing point of the domain outline
-    - tracks :            followed by an ARGUS file that prescribes the tracks that the mesh will stick to
-    - RequiredVertices :  mesh vertices that are required. [x, y, ref]; ref is optional
-    - tol :               if the distance between 2 points of the domain outline is less than tol, they
-                             will be merged
+    - domain :                              followed by an ARGUS file that 
+                                            prescribes the domain outline
+    - holes :                               followed by an ARGUS file that 
+                                            prescribes the holes
+    - subdomains :                          followed by an ARGUS file that 
+                                            prescribes the list of subdomains 
+                                            (that need to be inside domain)
+
+    - hmin :                                minimum edge length (default is 
+                                            1.0e-100)
+    - hmax :                                maximum edge length (default is 
+                                            1.0e100)
+    - hVertices :                           imposed edge length for each vertex 
+                                            (geometry or mesh)
+    - hminVertices :                        minimum edge length for each vertex 
+                                            (mesh)
+    - hmaxVertices :                        maximum edge length for each vertex 
+                                            (mesh)
+
+    - anisomax :                            maximum ratio between the smallest 
+                                            and largest edges (default is 
+                                            1.0e30)
+    - coeff :                               coefficient applied to the metric 
+                                            (2 -> twice as many elements, 
+                                            default is 1)
+    - cutoff :                              scalar used to compute the metric 
+                                            when metric type 2 or 3 are applied
+    - err :                                 error used to generate the metric 
+                                            from a field
+    - errg :                                geometric error (default is 0.1)
+    - field :                               field of the model that will be 
+                                            used to compute the metric to apply 
+                                            several fields, use one column per 
+                                            field
+    - gradation :                           maximum ratio between two adjacent 
+                                            edges
+    - Hessiantype :                         0 -> use double P2 projection 
+                                            (default)
+                                            1 -> use Green formula
+    - KeepVertices :                        try to keep initial vertices when 
+                                            adaptation is done on an existing 
+                                            mesh (default 1)
+    - NoBoundaryRefinement :                do not refine boundary, only follow 
+                                            contour provided (default 0). Allow 
+                                            subdomain boundary refinement 
+                                            though
+    - NoBoundaryRefinementAllBoundaries :   do not refine boundary, only follow 
+                                            contour provided (default 0)
+    - maxnbv :                              maximum number of vertices used to 
+                                            allocate memory (default is 1.0e6)
+    - maxsubdiv :                           maximum subdivision of exisiting 
+                                            elements (default is 10)
+    - metric :                              matrix (numberofnodes x 3) used as 
+                                            a metric
+    - Metrictype :                          1 -> absolute error 
+                                            c/(err coeff^2) * Abs(H) (default)
+                                            2 -> relative error 
+                                            c / (err coeff^2) * Abs(H) / 
+                                            max(s, cutoff * max(s))
+                                            3 -> rescaled absolute error 
+                                            c / (err coeff^2) * Abs(H) / 
+                                            (smax - smin)
+    - nbjacoby :                            correction used by Hessiantype = 1 
+                                            (default is 1)
+    - nbsmooth :                            number of metric smoothing 
+                                            procedure (default is 3)
+    - omega :                               relaxation parameter of the 
+                                            smoothing procedure (default is 
+                                            1.8)
+    - power :                               power applied to the metric 
+                                            (default is 1)
+    - splitcorners :                        split triangles which have 3 
+                                            vertices on the outline (default is 
+                                            1)
+    - verbose :                             level of verbosity (default is 1)
+
+    - rifts :                               followed by an ARGUS file that 
+                                            prescribes the rifts
+    - toltip :                              tolerance to move tip on an 
+                                            existing point of the domain 
+                                            outline
+    - tracks :                              followed by an ARGUS file that 
+                                            prescribes the tracks that the mesh 
+                                            will stick to
+    - RequiredVertices :                    mesh vertices that are required. 
+                                            [x, y, ref]; ref is optional
+    - tol :                                 if the distance between 2 points of 
+                                            the domain outline is less than 
+                                            tol, they will be merged
 
     Examples:
@@ -76,9 +122,9 @@
     """
 
-    #process options
+    # Process options
     options = pairoptions(*args)
     #options = deleteduplicates(options, 1)
 
-    #initialize the structures required as input of Bamg
+    # Initialize the structures required as input of Bamg
     bamg_options = OrderedDict()
     bamg_geometry = bamggeom()
@@ -138,5 +184,5 @@
                         holes = holesfile
                     else:
-                        raise Exception("bamg error message: if 'holes' is a list, its elements must be of type dict or OrderedDict")
+                        raise Exception('bamg error message: if \'holes\' is a list, its elements must be of type dict or OrderedDict')
                 else:
                     holes = holesfile
@@ -144,5 +190,5 @@
                 holes = [holesfile]
             else:
-                raise Exception("'holes' type {} not supported yet".format(type(holesfile)))
+                raise Exception('\'holes\' type {} not supported yet'.format(type(holesfile)))
 
         subdomains = []
@@ -151,5 +197,5 @@
             if type(subdomainsfile) == str:
                 if not os.path.exists(subdomainsfile):
-                    raise IOError("bamg error message: file {} not found".format(subdomainsfile))
+                    raise IOError('bamg error message: file {} not found'.format(subdomainsfile))
 
                 # Read subdomains accoridng to its extension
@@ -166,5 +212,5 @@
                         subdomains = subdomainsfile
                     else:
-                        raise Exception("bamg error message: if 'subdomains' is a list, its elements must be of type dict or OrderedDict")
+                        raise Exception('bamg error message: if \'subdomains\' is a list, its elements must be of type dict or OrderedDict')
                 else:
                     subdomains = subdomainsfile
@@ -172,5 +218,5 @@
                 subdomains = [subdomainsfile]
             else:
-                raise Exception("'subdomains' type {} not supported yet".format(type(subdomainsfile)))
+                raise Exception('\'subdomains\' type {} not supported yet'.format(type(subdomainsfile)))
 
         # Build geometry
@@ -179,5 +225,5 @@
             # Check that the domain is closed
             if (domain[i]['x'][0] != domain[i]['x'][-1] or domain[i]['y'][0] != domain[i]['y'][-1]):
-                raise RuntimeError("bamg error message: all contours provided in ''domain'' should be closed")
+                raise RuntimeError('bamg error message: all contours provided in \'domain\' should be closed')
 
             # Check that all holes are INSIDE the principle domain outline
@@ -185,5 +231,5 @@
                 flags = ContourToNodes(domain[i]['x'], domain[i]['y'], [domain[0]], 0)[0] # NOTE: Down stack call to FetchPythonData requires contour to be a list of struct if we are not passing in a path to a file, hence the odd addressing: '[domain[0]]'
                 if np.any(np.logical_not(flags)):
-                    raise RuntimeError("bamg error message: All holes should be strictly inside the principal domain")
+                    raise RuntimeError('bamg error message: All holes should be strictly inside the principal domain')
 
             # Check orientation
@@ -221,10 +267,10 @@
             # heck that the hole is closed
             if (holes[i]['x'][0] != holes[i]['x'][-1] or holes[i]['y'][0] != holes[i]['y'][-1]):
-                raise RuntimeError("bamg error message: all contours provided in ''hole'' should be closed")
+                raise RuntimeError('bamg error message: all contours provided in \'hole\' should be closed')
 
             # Check that all holes are INSIDE the principal domain (principal domain should be index 0)
             flags = ContourToNodes(holes[i]['x'], holes[i]['y'], [domain[0]], 0)[0] # NOTE: Down stack call to FetchPythonData requires contour to be a list of struct if we are not passing in a path to a file, hence the odd addressing: '[domain[0]]'
             if np.any(np.logical_not(flags)):
-                raise RuntimeError("bamg error message: All holes should be strictly inside the principal domain")
+                raise RuntimeError('bamg error message: All holes should be strictly inside the principal domain')
 
             # Check that hole is correctly oriented
@@ -249,10 +295,10 @@
             # Check that the subdomain is closed
             if (subdomains[i]['x'][0] != subdomains[i]['x'][-1] or subdomains[i]['y'][0] != subdomains[i]['y'][-1]):
-                raise RuntimeError("bamg error message: all contours provided in ''subdomains'' should be closed")
+                raise RuntimeError('bamg error message: all contours provided in \'subdomains\' should be closed')
 
             # Check that all subdomains are INSIDE the principal domain (principal domain should be index 0)
             flags = ContourToNodes(subdomains[i]['x'], subdomains[i]['y'], [domain[0]], 0)[0] # NOTE: Down stack call to FetchPythonData requires contour to be a list of struct if we are not passing in a path to a file, hence the odd addressing: '[domain[0]]'
             if np.any(np.logical_not(flags)):
-                raise RuntimeError("bamg error message: All subdomains should be strictly inside the principal domain")
+                raise RuntimeError('bamg error message: All subdomains should be strictly inside the principal domain')
 
             # Check that subdomain is correctly oriented
@@ -277,5 +323,5 @@
         if options.getfieldvalue('vertical', 0):
             if np.size(options.getfieldvalue('Markers', [])) != np.size(bamg_geometry.Edges, 0):
-                raise RuntimeError('for 2d vertical mesh, ''Markers'' option is required, and should be of size ' + str(np.size(bamg_geometry.Edges, 0)))
+                raise RuntimeError('for 2d vertical mesh, \'Markers\' option is required, and should be of size {}'.format(str(np.size(bamg_geometry.Edges, 0))))
         if np.size(options.getfieldvalue('Markers', [])) == np.size(bamg_geometry.Edges, 0):
             bamg_geometry.Edges[:, 2] = options.getfieldvalue('Markers')
@@ -291,5 +337,5 @@
                 rift = shpread(riftfile)
             else:
-                raise IOError("bamg error message: file '{}' format not supported (.exp or .shp)".format(riftfile))
+                raise IOError('bamg error message: file \'{}\' format not supported (.exp or .shp)'.format(riftfile))
 
             for i in range(len(rift)):
@@ -297,12 +343,12 @@
                 flags = ContourToNodes(rift[i]['x'], rift[i]['y'], [domain[0]], 0)[0] # NOTE: Down stack call to FetchPythonData requires contour to be a list of struct if we are not passing in a path to a file, hence the odd addressing: '[domain[0]]'
                 if np.all(np.logical_not(flags)):
-                    raise RuntimeError("one rift has all its points outside of the domain outline")
+                    raise RuntimeError('one rift has all its points outside of the domain outline')
                 elif np.any(np.logical_not(flags)):
                     # We have LOTS of work to do
-                    print("Rift tip outside of or on the domain has been detected and is being processed...")
+                    print('Rift tip outside of or on the domain has been detected and is being processed...')
 
                     # Check that only one point is outside (for now)
                     if np.sum(np.logical_not(flags).astype(int)) != 1:
-                        raise RuntimeError("bamg error message: only one point outside of the domain is supported at this time")
+                        raise RuntimeError('bamg error message: only one point outside of the domain is supported at this time')
 
                     # Move tip outside to the first position
@@ -314,5 +360,5 @@
                         rift[i]['y'] = np.flipud(rift[i]['y'])
                     else:
-                        raise RuntimeError("bamg error message: only a rift tip can be outside of the domain")
+                        raise RuntimeError('bamg error message: only a rift tip can be outside of the domain')
 
                     # Get coordinate of intersection point
@@ -341,5 +387,5 @@
 
                             if np.min(tipdis) / segdis < options.getfieldvalue('toltip', 0):
-                                print("moving tip-domain intersection point")
+                                print('moving tip-domain intersection point')
 
                                 # Get position of the closer point
@@ -370,5 +416,5 @@
                                 pos = np.nonzero(np.logical_and(bamg_geometry.Edges[:, 0] == i1, bamg_geometry.Edges[:, 1] == i2))[0]
                                 if not pos:
-                                    raise RuntimeError("bamg error message: a problem occurred...")
+                                    raise RuntimeError('bamg error message: a problem occurred...')
                                 bamg_geometry.Edges = np.vstack((
                                     bamg_geometry.Edges[0:pos - 1, :],
@@ -507,7 +553,7 @@
     # Bamg options {{{
     bamg_options['Crack'] = options.getfieldvalue('Crack', 0)
-    bamg_options['anisomax'] = options.getfieldvalue('anisomax', 10.**18)
-    bamg_options['coeff'] = options.getfieldvalue('coeff', 1.)
-    bamg_options['cutoff'] = options.getfieldvalue('cutoff', 10.**-5)
+    bamg_options['anisomax'] = options.getfieldvalue('anisomax', pow(10.0, 18))
+    bamg_options['coeff'] = options.getfieldvalue('coeff', 1.0)
+    bamg_options['cutoff'] = options.getfieldvalue('cutoff', pow(10.0, -5))
     bamg_options['err'] = options.getfieldvalue('err', np.array([[0.01]]))
     bamg_options['errg'] = options.getfieldvalue('errg', 0.1)
@@ -515,12 +561,12 @@
     bamg_options['gradation'] = options.getfieldvalue('gradation', 1.5)
     bamg_options['Hessiantype'] = options.getfieldvalue('Hessiantype', 0)
-    bamg_options['hmin'] = options.getfieldvalue('hmin', 10.**-100)
-    bamg_options['hmax'] = options.getfieldvalue('hmax', 10.**100)
+    bamg_options['hmin'] = options.getfieldvalue('hmin', pow(10.0, -100))
+    bamg_options['hmax'] = options.getfieldvalue('hmax', pow(10.0, 100))
     bamg_options['hminVertices'] = options.getfieldvalue('hminVertices', np.empty((0, 1)))
     bamg_options['hmaxVertices'] = options.getfieldvalue('hmaxVertices', np.empty((0, 1)))
     bamg_options['hVertices'] = options.getfieldvalue('hVertices', np.empty((0, 1)))
     bamg_options['KeepVertices'] = options.getfieldvalue('KeepVertices', 1)
-    bamg_options['maxnbv'] = options.getfieldvalue('maxnbv', 10**6)
-    bamg_options['maxsubdiv'] = options.getfieldvalue('maxsubdiv', 10.)
+    bamg_options['maxnbv'] = options.getfieldvalue('maxnbv', pow(10, 6))
+    bamg_options['maxsubdiv'] = options.getfieldvalue('maxsubdiv', 10.0)
     bamg_options['metric'] = options.getfieldvalue('metric', np.empty((0, 1)))
     bamg_options['Metrictype'] = options.getfieldvalue('Metrictype', 0)
@@ -528,5 +574,5 @@
     bamg_options['nbsmooth'] = options.getfieldvalue('nbsmooth', 3)
     bamg_options['omega'] = options.getfieldvalue('omega', 1.8)
-    bamg_options['power'] = options.getfieldvalue('power', 1.)
+    bamg_options['power'] = options.getfieldvalue('power', 1.0)
     bamg_options['splitcorners'] = options.getfieldvalue('splitcorners', 1)
     bamg_options['verbose'] = options.getfieldvalue('verbose', 1)
@@ -595,7 +641,7 @@
     md.mesh.elementconnectivity = md.mesh.elementconnectivity.astype(int)
 
-    #Check for orphan
+    # Check for orphan
     if np.any(np.logical_not(np.in1d(np.arange(1, md.mesh.numberofvertices + 1), md.mesh.elements.flat))):
-        raise RuntimeError("Output mesh has orphans. Check your Domain and / or RequiredVertices")
+        raise RuntimeError('Output mesh has orphans. Check your Domain and/or RequiredVertices')
 
     return md
@@ -603,8 +649,8 @@
 
 def processgeometry(geom, tol, outline):  # {{{
-    raise RuntimeError("bamg.py::processgeometry is not complete.")
+    raise RuntimeError('bamg.py::processgeometry is not complete.')
 
     # Deal with edges
-    print("Checking Edge crossing...")
+    print('Checking Edge crossing...')
     i = 0
     while (i < np.size(geom.Edges, axis=0)):
@@ -659,5 +705,5 @@
 
     # Check point outside
-    print("Checking for points outside the domain...")
+    print('Checking for points outside the domain...')
     i = 0
     num = 0
@@ -687,5 +733,5 @@
 
     if num:
-        print(("WARNING: %d points outside the domain outline have been removed" % num))
+        print(('WARNING: {} points outside the domain outline have been removed'.format(num)))
 
     """
Index: issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.js
===================================================================
--- issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.js	(revision 26744)
+++ issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.js	(revision 26744)
@@ -0,0 +1,60 @@
+//GMSHPLANET - mesh generation for a sphere. Very specific code for gmsh from $ISSM_DIR/src/demos/simple_geo/sphere.geo
+//
+//   Available options (for more details see ISSM website http://issm.jpl.nasa.gov/):
+//
+//   - radius:             radius of the planet in km
+//   - resolution:         resolution in km
+//   - refine:             provide mesh
+//   - refinemetric:       mesh quantity to specify resolution
+//
+//   Returns 'mesh3dsurface' type mesh
+//
+//   Examples:
+//      md.mesh=gmshplanet('radius',6000,'resolution',100);
+//      md.mesh=gmshplanet('radius',6000,'resolution',100);
+async function gmshplanet(md) {
+	let args = Array.prototype.slice.call(arguments, 1);
+	let options = new pairoptions(args);
+	let radius = options.getfieldvalue('radius', planetradius('earth')); //warning: planetradius in m, not km
+	let resolution = options.getfieldvalue('resolution', 700);
+
+	md.cluster = cluster;
+	md = await solve(md, 'gmsh', 'checkconsistency', 'false', 'hmin', resolution);
+
+	//methods 
+	let results = md.results[0];
+	let mesh = new mesh3dsurface();
+	let elements = [];
+	for (let i = 0; i < results.Elements.length; i=i+3){
+		elements.push(results.Elements.slice(i, i+3));
+	}
+	mesh.numberofelements = results.NumberOfElements;
+	mesh.numberofvertices =  results.NumberOfVertices;
+	mesh.x = results.X;
+	mesh.y = results.Y;
+	mesh.z = results.Z;
+	mesh.r = results.R;
+	mesh.elements = elements;
+	mesh.lat = results.Lat;
+	mesh.long = results.Long;
+	mesh.average_vertex_connectivity = results.AverageVertexConnectivity;
+
+	//a little technicality here. the mesh generate is not exactly on the 
+	//sphere. we create lat,long coordinates, and reproject on an exact sphere. 
+	mesh.r=ArraySqrt(ArrayAdd(ArrayAdd(ArrayPow(mesh.x,2),ArrayPow(mesh.y,2)),ArrayPow(mesh.z,2)));
+
+	//make sure we don't have south and north pole: 
+	let pos=find(ArrayAnd(ArrayEqual(mesh.x,0), ArrayEqual(mesh.y,0)));
+	mesh.lat = asind(ArrayDivide(mesh.z,mesh.r));
+	mesh.long = atan2d(mesh.y,mesh.x);
+	pos=find(ArrayEqual(mesh.lat,90)); ArrayIndex(mesh.lat,pos,90-.01);
+	pos=find(ArrayEqual(mesh.lat,-90)); ArrayIndex(mesh.lat,pos,-90+.01);
+
+	let radius = planetradius('earth');
+	mesh.r=NewArrayFill(mesh.numberofvertices,radius);
+	mesh.x=ArrayMultiply(radius,ArrayMultiply(cosd(mesh.lat),cosd(mesh.long)));
+	mesh.y=ArrayMultiply(radius,ArrayMultiply(cosd(mesh.lat),sind(mesh.long)));
+	mesh.z=ArrayMultiply(radius,sind(mesh.lat));
+
+	return mesh;
+}
Index: issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m
===================================================================
--- issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m	(revision 25994)
+++ issm/trunk/src/m/mesh/planet/gmsh/gmshplanet.m	(revision 26744)
@@ -15,23 +15,6 @@
 %      md.mesh=gmshplanet('radius',6000,'resolution',100);
 
-	%Find path to gmsh
-	paths = {...
-		[issmdir() 'bin/gmsh'],...
-		[issmdir() 'externalpackages/gmsh/install/gmsh']...
-	};
-	disp(paths{1})
-	gmshpath = '';
-	for i=paths
-		if exist(i{1},'file'),
-			gmshpath = i{1};
-			break;
-		end
-	end
-	if isempty(gmshpath),
-		error('gmsh not found, make sure it is properly installed');
-	end
-
 	% Get Gmsh version
-	[s,r]=system([gmshpath ' -info 2>&1 | command grep ''Version'' | sed -e ''s/Version[[:blank:]]*:[[:blank:]]//'' | cut -d ''.'' -f1']);
+	[s,r]=system(['gmsh -info 2>&1 | command grep ''Version'' | sed -e ''s/Version[[:blank:]]*:[[:blank:]]//'' | cut -d ''.'' -f1']);
 	if s~=0,
 		error(r);
@@ -56,10 +39,21 @@
 	fid=fopen('sphere.geo','w');
 
-	fprintf(fid,'Mesh.Algorithm = 1;\n');
+	% NOTE:
+	% - The default format in Gmsh 3 is "msh2". Rather than conditionally 
+	% modifying our parsing scheme for Gmsh 4, for now, we simply set the 
+	% 'Mesh.MshFileVersion' option.
+	% - Decreasing the value of the 'Mesh.RandomFactor' option leads to an 
+	% equal number of nodes and elements being produced under macOS and Linux 
+	% at certain resolutions using certain meshing algorithms.
+	%
+	fprintf(fid,'Mesh.Algorithm = 1;\n'); % MeshAdapt
+	fprintf(fid,'Mesh.MshFileVersion = 2;\n');
+	fprintf(fid,'Mesh.RandomFactor = 1e-10;\n');
 	if  exist(options,'refine'),
-		fprintf(fid,'Mesh.Algorithm = 7;\n');
-		fprintf(fid,'Mesh.CharacteristicLengthFromPoints= 0;\n');
-		fprintf(fid,'Mesh.SmoothRatio= 3;\n');
-		fprintf(fid,'Mesh.RemeshAlgorithm= 1;\n');
+		fprintf(fid,'Mesh.Algorithm = 7;\n'); % BAMG
+		fprintf(fid,'Mesh.CharacteristicLengthFromPoints = 0;\n');
+		if gmshmajorversion == 3,
+			fprintf(fid,'Mesh.RemeshAlgorithm = 1;\n');
+		end
 	end
 	fprintf(fid,'resolution=%g;\n',resolution);
@@ -137,13 +131,8 @@
 
 	% Call gmsh
-	%
-	% NOTE: The default format in Gmsh 3 is "msh2". Rather than conditionally 
-	%		modifying our parsing scheme for Gmsh 4, for now, we simply set the 
-	%		"-format" option.
-	%
 	if  exist(options,'refine'),
-		system([gmshpath ' -tol 1e-8 -2 -format msh2 sphere.geo -bgm sphere.pos']);
+		system(['gmsh -2 sphere.geo -bgm sphere.pos']);
 	else
-		system([gmshpath ' -tol 1e-8 -2 -format msh2 sphere.geo']);
+		system(['gmsh -2 sphere.geo']);
 	end
 
@@ -195,8 +184,19 @@
 	%}}}
 
-	%figure out other fields in mesh3dsurface:
+	%a little technicality here. the mesh generate is not exactly on the 
+	%sphere. we create lat,long coordinates, and reproject on an exact sphere. 
 	mesh.r=sqrt(mesh.x.^2+mesh.y.^2+mesh.z.^2);
-	mesh.lat = asin(mesh.z./mesh.r)/pi*180;
-	mesh.long = atan2(mesh.y,mesh.x)/pi*180;
+
+	%make sure we don't have south and north pole: 
+	pos=find(mesh.x==0 & mesh.y==0);
+	mesh.lat = asind(mesh.z./mesh.r);
+	mesh.long = atan2d(mesh.y,mesh.x);
+	pos=find(mesh.lat==90); mesh.lat(pos)=90-.01;
+	pos=find(mesh.lat==-90); mesh.lat(pos)=-90+.01;
+
+	mesh.r=radius*ones(mesh.numberofvertices,1);
+	mesh.x=radius*cosd(mesh.lat).*cosd(mesh.long);
+	mesh.y=radius*cosd(mesh.lat).*sind(mesh.long);
+	mesh.z=radius*sind(mesh.lat);
 
 	%erase files:
